function [dimsizes,dat] = read_2d_binary_file(filename,precision)

    switch precision
        case 'single'
            fprintf('Single precision specified.\n');
        case 'double'
            fprintf('Double precision specified.\n');
        otherwise
            error('Expecting single or double precision.\n');
    end

    fileID = fopen(filename);
    
    d1 = fread(fileID,1,'int');
    d2 = fread(fileID,1,'int');
    
    dat = fread(fileID,d1*d2,precision);
    dat = permute(reshape(dat,[d2 d1]),[2 1]);
    
    dimsizes = [d1 d2];

    fclose(fileID);

end