function T = OutputParameters(p)

    NumEntries = 7;

    symbol = cell(NumEntries,1);
    description = cell(NumEntries,1);
    value = zeros(NumEntries,1);
    
    idx = 0;
    
    idx = idx + 1;
    symbol{idx} = '$\gamma$';
    description{idx} = 'Sovereign''s risk aversion';
    value(idx) = p.rra;
    
    idx = idx + 1;
    symbol{idx} = '$\rho_z$';
    description{idx} = 'Persistence of output';
    value(idx) = sqrt(p.sigma_tfp^2 + p.ggq_mstd^2);
    
    idx = idx + 1;
    symbol{idx} = '$r$';
    description{idx} = 'Discount rate of international investors';
    value(idx) = p.rH;
    
    idx = idx + 1;
    symbol{idx} = '$m$';
    description{idx} = 'Rate at which debt matures';
    value(idx) = p.debt_m;
    
    idx = idx + 1;
    symbol{idx} = '$z$';
    description{idx} = 'Coupon rate';
    value(idx) = p.debt_z;
    
    idx = idx + 1;
    symbol{idx} = '$\theta$';
    description{idx} = 'Probability of reentry';
    value(idx) = p.reenterprob;
    
    idx = idx + 1;
    symbol{idx} = '$\overline{\delta}$';
    description{idx} = 'Maximum default probability';
    value(idx) = p.max_def_prob;
    
    idx = idx + 1;
    symbol{idx} = '$\alpha_{ND}$';
    description{idx} = 'Bargaining power, investors, ND';
    value(idx) = 1 - p.bargain_power_mkt_maker_ND;
    
    idx = idx + 1;
    symbol{idx} = '$\alpha_{D}$';
    description{idx} = 'Bargaining power, investors, D';
    value(idx) = 1 - p.bargain_power_mkt_maker_D;
    
    idx = idx + 1;
    symbol{idx} = '$\alpha_{ND}$';
    description{idx} = 'Bargaining power, investors, ND';
    value(idx) = 1 - p.bargain_power_mkt_maker_ND;
    
    idx = idx + 1;
    symbol{idx} = '$\alpha_{ND}$';
    description{idx} = 'Bargaining power, investors, ND';
    value(idx) = 1 - p.bargain_power_mkt_maker_ND;
    
    idx = idx + 1;
    symbol{idx} = '$\beta$';
    description{idx} = 'Sovereign''s discount rate';
    value(idx) = p.beta;
    
    idx = idx + 1;
    symbol{idx} = '$\overline{b}$';
    description{idx} = 'Maximum recovery for sovereign bonds';
    value(idx) = p.recovery_bmax;
    
    idx = idx + 1;
    symbol{idx} = '$d_y$';
    description{idx} = 'Output costs for default';
    value(idx) = p.d_y;
    
    idx = idx + 1;
    symbol{idx} = '$d_{yy}$';
    description{idx} = 'Output costs for default';
    value(idx) = p.d_yy;
    
    idx = idx + 1;
    symbol{idx} = '$h_c$';
    description{idx} = 'Holding costs for constrained investors';
    value(idx) = p.holding_cost;
    
    idx = idx + 1;
    symbol{idx} = '$\zeta$';
    description{idx} = 'Probability of getting a liquidity shock';
    value(idx) = p.prob_liqshock;

    T = table(symbol, description, value);

end