set(0,'DefaultFigureWindowStyle','docked')
clear all

% load('baseline_11042020.mat','p','model')
load('baseline_11042020_ver2.mat','p','model')

%% plot bond prices

LineWidth = 2;
FontSize = 18;
LegendFontSize = 18;

% STD_DEV = 2;
STD_DEV = 1;

[~,idxH] = min(abs(log(p.grid_y_nd) - STD_DEV*p.sigma_tfp/sqrt(1-p.rho_tfp^2)));
[~,idxL] = min(abs(log(p.grid_y_nd) + STD_DEV*p.sigma_tfp/sqrt(1-p.rho_tfp^2)));

m0 = p.ggq_mmean;
% m0 = p.ggq_mlb;
% m0 = p.ggq_mub;
policy_idxH = NaN*zeros(size(p.grid_b));
policy_idxL = NaN*zeros(size(p.grid_b));

propba_ND_idxH_optim_bchoice = NaN*zeros(size(p.grid_b));
propba_ND_idxL_optim_bchoice = NaN*zeros(size(p.grid_b));
propba_D_idxH_optim_bchoice = NaN*zeros(size(p.grid_b));
propba_D_idxL_optim_bchoice = NaN*zeros(size(p.grid_b));

ellND_idxH_optim_bchoice = NaN*zeros(size(p.grid_b));
ellND_idxL_optim_bchoice = NaN*zeros(size(p.grid_b));
ellND_nondef_idxH_optim_bchoice = NaN*zeros(size(p.grid_b));
ellND_nondef_idxL_optim_bchoice = NaN*zeros(size(p.grid_b));
ellND_def_idxH_optim_bchoice = NaN*zeros(size(p.grid_b));
ellND_def_idxL_optim_bchoice = NaN*zeros(size(p.grid_b));
defprob_idxH_optim_bchoice = NaN*zeros(size(p.grid_b));
defprob_idxL_optim_bchoice = NaN*zeros(size(p.grid_b));
for i = 1:p.gridsize_b
    if m0>=model.defthresh(idxH,i)
        idx = find(model.policy{idxH,i}.eps_mesh(1:end-1)<=m0 & m0<=model.policy{idxH,i}.eps_mesh(2:end),1,'first');
        policy_idxH(i) = model.policy{idxH,i}.idx_bnext(idx);
        ellND_idxH_optim_bchoice(i) = model.ellND(idxH,policy_idxH(i));
        ellND_nondef_idxH_optim_bchoice(i) = model.ellND_nondef_term(idxH,policy_idxH(i));
        ellND_def_idxH_optim_bchoice(i) = model.ellND_def_term(idxH,policy_idxH(i));
        defprob_idxH_optim_bchoice(i) = model.defprob(idxH,policy_idxH(i));
        qH = model.qNDH(idxH,policy_idxH(i));
        qsale = p.bargain_power_mkt_maker_ND*model.qNDL(idxH,policy_idxH(i)) + (1-p.bargain_power_mkt_maker_ND)*model.qNDH(idxH,policy_idxH(i));
        propba_ND_idxH_optim_bchoice(i) = 2*(qH - qsale)/(qH + qsale);
        qH = model.qDH(idxH,i); % bdef
        qsale = p.bargain_power_mkt_maker_D*model.qDL(idxH,i) + (1-p.bargain_power_mkt_maker_D)*model.qDH(idxH,i);
        propba_D_idxH_optim_bchoice(i) = 2*(qH - qsale)/(qH + qsale);
    end
    if m0>=model.defthresh(idxL,i)
        idx = find(model.policy{idxL,i}.eps_mesh(1:end-1)<=m0 & m0<=model.policy{idxL,i}.eps_mesh(2:end),1,'first');
        policy_idxL(i) = model.policy{idxL,i}.idx_bnext(idx);
        ellND_idxL_optim_bchoice(i) = model.ellND(idxL,policy_idxL(i));
        ellND_nondef_idxL_optim_bchoice(i) = model.ellND_nondef_term(idxL,policy_idxL(i));
        ellND_def_idxL_optim_bchoice(i) = model.ellND_def_term(idxL,policy_idxL(i));
        defprob_idxL_optim_bchoice(i) = model.defprob(idxL,policy_idxL(i));
        qH = model.qNDH(idxL,policy_idxL(i));
        qsale = p.bargain_power_mkt_maker_ND*model.qNDL(idxL,policy_idxL(i)) + (1-p.bargain_power_mkt_maker_ND)*model.qNDH(idxL,policy_idxL(i));
        propba_ND_idxL_optim_bchoice(i) = 2*(qH - qsale)/(qH + qsale);
        qH = model.qDH(idxL,i);
        qsale = p.bargain_power_mkt_maker_D*model.qDL(idxL,i) + (1-p.bargain_power_mkt_maker_D)*model.qDH(idxL,i);
        propba_D_idxL_optim_bchoice(i) = 2*(qH - qsale)/(qH + qsale);
    end
end

%% plot 1

figure

subplot(1,2,1)
hold on
temp = model.ellND(idxL,:);
temp(model.defprob(idxL,:)>p.max_def_prob) = NaN;
plot(p.grid_b/3,temp,'--k','LineWidth',LineWidth)
plot(p.grid_b/3,ellND_idxL_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,model.ellD(idxL,:),'-.r','LineWidth',LineWidth)
xlabel('$b/3$ or $b''/3$','Interpreter','Latex','FontSize',FontSize)
legend({'$\ell_{ND}(y,b'')$','$\ell_{ND}(y,b'')$, optimal $b''$','$\ell_D(y,b)$'},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
legend boxoff
title('A. Low output','Interpreter','Latex','FontSize',FontSize)
ylabel('$\ell$','Interpreter','Latex','FontSize',FontSize)

subplot(1,2,2)
hold on
temp = model.ellND(idxH,:);
temp(model.defprob(idxH,:)>p.max_def_prob) = NaN;
plot(p.grid_b/3,temp,'--k','LineWidth',LineWidth)
plot(p.grid_b/3,ellND_idxH_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,model.ellD(idxH,:),'-.r','LineWidth',LineWidth)
xlabel('$b/3$ or $b''/3$','Interpreter','Latex','FontSize',FontSize)
legend({'$\ell_{ND}(y,b'')$','$\ell_{ND}(y,b'')$, optimal $b''$','$\ell_D(y,b)$'},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
legend boxoff
title('B. High output','Interpreter','Latex','FontSize',FontSize)
ylabel('$\ell$','Interpreter','Latex','FontSize',FontSize)

%% plot 2

figure
hold on
temp1 = model.defprob(idxL,:);
temp2 = ellND_idxL_optim_bchoice;
scatter(temp1(temp1<=p.max_def_prob),temp2(temp1<=p.max_def_prob),'o','LineWidth',LineWidth)
temp1 = model.defprob(idxH,:);
temp2 = ellND_idxH_optim_bchoice;
scatter(temp1(temp1<=p.max_def_prob),temp2(temp1<=p.max_def_prob),'x','LineWidth',LineWidth)
xlabel('Default probability, $p_{def}(y,b)$','Interpreter','Latex','FontSize',FontSize)
ylabel('$\ell_{ND}$, optimal $b''$','Interpreter','Latex','FontSize',FontSize)
title('Scatter plot: $p_{def}$ vs $\ell_{ND}$','Interpreter','Latex','FontSize',FontSize)

%% default probs

figure

subplot(1,2,1)
hold on
plot(p.grid_b/3,model.defprob(idxH,:),'-b','LineWidth',LineWidth)
plot(p.grid_b/3,model.defprob(idxL,:),'-.r','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('A. Default probability','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt choice, $b''/3$','Interpreter','Latex','FontSize',FontSize)
legend({['High output'],['Low output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')

subplot(1,2,2)
hold on
plot(p.grid_b/3,defprob_idxH_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,defprob_idxL_optim_bchoice,'-.r','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('B. Default probability, at optimal $b''$','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt level, $b/3$','Interpreter','Latex','FontSize',FontSize)
legend({['High output'],['Low output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')
% set(gca,'ylim',[0 0.004])

%% fix the stock variable b, plot as function of flow variable

m0 = p.ggq_mmean;

b0 = 3;
% b0 = 4;
[~,idx_b0] = min(abs(b0 - p.grid_b));

ellND = NaN*zeros(p.gridsize_tfp,1);
ellND_d0 = NaN*zeros(p.gridsize_tfp,1);
ellND_d1 = NaN*zeros(p.gridsize_tfp,1);
defprob = NaN*zeros(p.gridsize_tfp,1);

for idx_y0 = 1:p.gridsize_tfp
    if m0>=model.defthresh(idx_y0,idx_b0)
        idx = find(model.policy{idx_y0,idx_b0}.eps_mesh(1:end-1)<=m0 & ...
            m0<=model.policy{idx_y0,idx_b0}.eps_mesh(2:end),1,'first');
        idx_bchoice = model.policy{idx_y0,idx_b0}.idx_bnext(idx);
        ellND(idx_y0) = model.ellND(idx_y0,idx_bchoice);
        ellND_d1(idx_y0) = model.ellND_def_term(idx_y0,idx_bchoice);
        ellND_d0(idx_y0) = model.ellND_nondef_term(idx_y0,idx_bchoice);
        defprob(idx_y0) = model.defprob(idx_y0,idx_bchoice);
    end
end

figure

subplot(2,2,1)
hold on
plot(p.grid_y_nd,10000*ellND,':k','LineWidth',LineWidth)
plot(p.grid_y_nd,10000*ellND_d0,'-b','LineWidth',LineWidth)
plot(p.grid_y_nd,10000*ellND_d1,'-.r','LineWidth',LineWidth)
legend({'$\ell_{ND}$','$\ell_{ND}^{d=0}$','$\ell_{ND}^{d=1}$'},...
    'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthEast');
legend boxoff
title('A. Liquidity premium','Interpreter','Latex','FontSize',FontSize)
xlabel('Output, $y''$','Interpreter','Latex','FontSize',FontSize)
ylabel('Basis points','Interpreter','Latex','FontSize',FontSize)

subplot(2,2,2)
hold on
plot(p.grid_y_nd,10000*(ellND_d1 - ellND_d0),'-b','LineWidth',LineWidth)
legend({'$\ell_{ND}^{d=1}-\ell_{ND}^{d=0}$'},...
    'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthEast');
legend boxoff
title('B. Liquidity premium difference','Interpreter','Latex','FontSize',FontSize)
xlabel('Output, $y''$','Interpreter','Latex','FontSize',FontSize)
ylabel('Basis points','Interpreter','Latex','FontSize',FontSize)

subplot(2,2,3)
hold on
plot(defprob,10000*ellND,':k','LineWidth',LineWidth)
plot(defprob,10000*ellND_d0,'-b','LineWidth',LineWidth)
plot(defprob,10000*ellND_d1,'-.r','LineWidth',LineWidth)
legend({'$\ell_{ND}$','$\ell_{ND}^{d=0}$','$\ell_{ND}^{d=1}$'},...
    'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
legend boxoff
title('C. Liquidity premium','Interpreter','Latex','FontSize',FontSize)
xlabel('Default probability, one period ahead','Interpreter','Latex','FontSize',FontSize)
ylabel('Basis points','Interpreter','Latex','FontSize',FontSize)

subplot(2,2,4)
hold on
plot(defprob,10000*(ellND_d1 - ellND_d0),'-b','LineWidth',LineWidth)
legend({'$\ell_{ND}^{d=1}-\ell_{ND}^{d=0}$'},...
    'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
legend boxoff
title('D. Liquidity premium difference','Interpreter','Latex','FontSize',FontSize)
xlabel('Default probability, one period ahead','Interpreter','Latex','FontSize',FontSize)
ylabel('Basis points','Interpreter','Latex','FontSize',FontSize)

figure
plot(defprob,(1+ellND).^12-1,'-b','LineWidth',LineWidth)
xlabel('Expected default probability, one period ahead','Interpreter','Latex','FontSize',22)
ylabel('Liquidity premium (annualized)','Interpreter','Latex','FontSize',22)
set(gca,'xlim',[0 0.5])

%% diagnostic plot

% y0 = 1;
y0 = 0.9;
% b0 = 3;
b0 = 4;
m0 = p.ggq_mmean;

[~,idx_y0] = min(abs(y0 - p.grid_y_nd));
[~,idx_b0] = min(abs(b0 - p.grid_b));

proploss_ND = NaN*zeros(p.gridsize_tfp,1);
proploss_D = NaN*zeros(p.gridsize_tfp,1);
proploss_D2 = NaN*zeros(p.gridsize_tfp,1);
qfrac = NaN*zeros(p.gridsize_tfp,1);

idx = find(model.policy{idx_y0,idx_b0}.eps_mesh(1:end-1)<=m0 & ...
    m0<=model.policy{idx_y0,idx_b0}.eps_mesh(2:end),1,'first');
idx_bchoice0 = model.policy{idx_y0,idx_b0}.idx_bnext(idx);

for i = 1:p.gridsize_tfp
    
    if m0>model.defthresh(i,idx_bchoice0)
        
        idx_next = find(model.policy{i,idx_bchoice0}.eps_mesh(1:end-1)<=m0 & ...
            m0<=model.policy{i,idx_bchoice0}.eps_mesh(2:end),1,'first');
        idx_bnext = model.policy{i,idx_bchoice0}.idx_bnext(idx_next);
        
        proploss_ND(i) = (model.qNDH(i,idx_bnext) - model.qNDL(i,idx_bnext))...
            /model.qNDH(idx_y0,idx_bchoice0);
        
        proploss_D(i) = (model.qDH(i,idx_bchoice0) - model.qDL(i,idx_bchoice0))...
            /model.qNDH(idx_y0,idx_bchoice0);
        
        proploss_D2(i) = (model.qDH(i,idx_bchoice0) - model.qDL(i,idx_bchoice0))...
            /model.qDH(idx_y0,idx_bchoice0);
        
        qfrac(i) = model.qDH(idx_y0,idx_bchoice0)/model.qNDH(idx_y0,idx_bchoice0);
    
    end
    
end

figure
hold on
plot(p.grid_y_nd,proploss_ND,'-b','LineWidth',LineWidth)
plot(p.grid_y_nd,proploss_D,'-.r','LineWidth',LineWidth)
plot(p.grid_y_nd,proploss_D2,'--k','LineWidth',LineWidth)
% plot(p.grid_y_nd,qfrac,':m','LineWidth',LineWidth)
axis square
box on
title('A. Proportional loss','Interpreter','Latex','FontSize',FontSize)
xlabel('Output next period, $y''$','Interpreter','Latex','FontSize',FontSize)
grid on
legend({'$(q_{ND}^H(y'',b'''')-q_{ND}^L(y'',b''''))/q_{ND}^H(y,b'')$',...
    '$(q_{D}^H(y'',b'')-q_{D}^L(y'',b''))/q_{ND}^H(y,b'')$',...
    '$(q_{D}^H(y'',b'')-q_{D}^L(y'',b''))/q_{D}^H(y,b'')$',...
    '$q_{D}^H(y,b'')/q_{ND}^H(y,b'')$'},...
    'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthEast');
legend('boxoff')

%% subcomponents of ellND

figure

subplot(1,3,1)
hold on
plot(p.grid_b/3,ellND_idxH_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,ellND_idxL_optim_bchoice,'-.r','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('A. Liquidity premium, $\ell_{ND}$, at optimal $b''$','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt level, $b/3$','Interpreter','Latex','FontSize',FontSize)
legend({['High output'],['Low output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')
set(gca,'xlim',[0.6 1.8])

subplot(1,3,2)
hold on
plot(p.grid_b/3,ellND_nondef_idxH_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,ellND_nondef_idxL_optim_bchoice,'-.r','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('B. Liquidity premium (not def), $\ell_{ND}^{d=0}$, at optimal $b''$','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt level, $b/3$','Interpreter','Latex','FontSize',FontSize)
legend({['High output'],['Low output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')
set(gca,'xlim',[0.6 1.8])

subplot(1,3,3)
hold on
plot(p.grid_b/3,ellND_def_idxH_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,ellND_def_idxL_optim_bchoice,'-.r','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('C. Liquidity premium (def), $\ell_{ND}^{d=1}$, at optimal $b''$','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt level, $b/3$','Interpreter','Latex','FontSize',FontSize)
legend({['High output'],['Low output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')
set(gca,'xlim',[0.6 1.8])

%% subcomponents, ver 2

figure

subplot(2,2,1)
hold on
plot(p.grid_b/3,ellND_idxH_optim_bchoice,':k','LineWidth',LineWidth)
plot(p.grid_b/3,ellND_nondef_idxH_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,ellND_def_idxH_optim_bchoice,'-.r','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('A. High output','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt level, $b/3$','Interpreter','Latex','FontSize',FontSize)
legend({'$\ell_{ND}$','$\ell_{ND}^{d=0}$','$\ell_{ND}^{d=0}$'},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')
% set(gca,'xlim',[0.6 1.8])

subplot(2,2,2)
hold on
plot(p.grid_b/3,ellND_idxL_optim_bchoice,':k','LineWidth',LineWidth)
plot(p.grid_b/3,ellND_nondef_idxL_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,ellND_def_idxL_optim_bchoice,'-.r','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('B. Low output','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt level, $b/3$','Interpreter','Latex','FontSize',FontSize)
legend({'$\ell_{ND}$','$\ell_{ND}^{d=0}$','$\ell_{ND}^{d=0}$'},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')
% set(gca,'xlim',[0.6 1.8])

subplot(2,2,3)
hold on
plot(p.grid_b/3,ellND_nondef_idxH_optim_bchoice - ellND_def_idxH_optim_bchoice,'-b','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('A. High output','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt level, $b/3$','Interpreter','Latex','FontSize',FontSize)
legend({'$\ell_{ND}^{d=0}-\ell_{ND}^{d=1}$'},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')
% set(gca,'xlim',[0.6 1.8])

%% proportional bid ask

figure

subplot(1,2,1)
hold on
plot(p.grid_b/3,propba_ND_idxH_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,propba_D_idxH_optim_bchoice,'-.r','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('A. High output','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt level, $b/3$','Interpreter','Latex','FontSize',FontSize)
legend({'$propba_{ND}$','$propba_{D}$'},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')
% set(gca,'xlim',[0.6 1.8])

subplot(1,2,2)
hold on
plot(p.grid_b/3,propba_ND_idxL_optim_bchoice,'-b','LineWidth',LineWidth)
plot(p.grid_b/3,propba_D_idxL_optim_bchoice,'-.r','LineWidth',LineWidth)
axis square
box on
% set(gca,'xlim',p.grid_b([1 end]))
% set(gca,'ylim',[0 1.205])
title('B. Low output','Interpreter','Latex','FontSize',FontSize)
xlabel('Debt level, $b/3$','Interpreter','Latex','FontSize',FontSize)
legend({'$propba_{ND}$','$propba_{D}$'},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% h = legend({['High',char(10),'output'],['Low',char(10),'output']},'Interpreter','Latex','FontSize',LegendFontSize,'Location','NorthWest');
% rect = [0.06, 0.3, .25, .25];
% set(h, 'Position', rect)
grid on
legend('boxoff')
% set(gca,'xlim',[0.6 1.8])

%% liquidity premium

illustration