set(0,'DefaultFigureWindowStyle','docked')
clear all

% load('baseline_11042020.mat','p','model')
% load('baseline_11042020_ver2.mat','p','model')

LineWidth = 3;
FontSize = 25;

%% plot baseline

load('baseline_11042020.mat','p','model')

m0 = p.ggq_mmean;
b0 = 3;

[~,idx_b0] = min(abs(b0 - p.grid_b));

ellND_base = NaN*zeros(p.gridsize_tfp,1);
defprob_base = NaN*zeros(p.gridsize_tfp,1);

for idx_y0 = 1:p.gridsize_tfp
    if m0>=model.defthresh(idx_y0,idx_b0)
        idx = find(model.policy{idx_y0,idx_b0}.eps_mesh(1:end-1)<=m0 & ...
            m0<=model.policy{idx_y0,idx_b0}.eps_mesh(2:end),1,'first');
        idx_bchoice = model.policy{idx_y0,idx_b0}.idx_bnext(idx);
        ellND_base(idx_y0) = model.ellND(idx_y0,idx_bchoice);
        defprob_base(idx_y0) = model.defprob(idx_y0,idx_bchoice);
    end
end

figure
hold on

plot(defprob_base,(1+ellND_base).^12 - 1,'-b','LineWidth',LineWidth)
title('Default probability vs. liquidity premium','Interpreter','Latex','FontSize',FontSize)
xlabel('Default probability','Interpreter','Latex','FontSize',FontSize)
ylabel('$\ell_{ND}$, annualized','Interpreter','Latex','FontSize',FontSize)
% set(gca,'xlim',[0 0.5])
% axis square

%% short term debt

% load('sensitivity analysis\sensitivity_one_period_debt.mat','p','model')
load('sensitivity analysis\sensitivity_one_year_debt.mat','p','model')

[~,idx_b0] = min(abs(b0 - p.grid_b));

ellND_m1 = NaN*zeros(p.gridsize_tfp,1);
defprob_m1 = NaN*zeros(p.gridsize_tfp,1);

for idx_y0 = 1:p.gridsize_tfp
    if m0>=model.defthresh(idx_y0,idx_b0)
        idx = find(model.policy{idx_y0,idx_b0}.eps_mesh(1:end-1)<=m0 & ...
            m0<=model.policy{idx_y0,idx_b0}.eps_mesh(2:end),1,'first');
        idx_bchoice = model.policy{idx_y0,idx_b0}.idx_bnext(idx);
        ellND_m1(idx_y0) = model.ellND(idx_y0,idx_bchoice);
        defprob_m1(idx_y0) = model.defprob(idx_y0,idx_bchoice);
    end
end

plot(defprob_m1,(1+ellND_m1).^12 - 1,'--r','LineWidth',LineWidth)
% title('B. Liquidity premium, $m=1$','Interpreter','Latex','FontSize',FontSize)
xlabel('Default probability','Interpreter','Latex','FontSize',FontSize)
ylabel('$\ell_{ND}$, annualized','Interpreter','Latex','FontSize',FontSize)
% set(gca,'xlim',[0 0.5])
% axis square

%% no recovery

load('sensitivity analysis\sensitivity_no_recovery.mat','p','model')

[~,idx_b0] = min(abs(b0 - p.grid_b));

ellND_no_rec = NaN*zeros(p.gridsize_tfp,1);
defprob_no_rec = NaN*zeros(p.gridsize_tfp,1);

for idx_y0 = 1:p.gridsize_tfp
    if m0>=model.defthresh(idx_y0,idx_b0)
        idx = find(model.policy{idx_y0,idx_b0}.eps_mesh(1:end-1)<=m0 & ...
            m0<=model.policy{idx_y0,idx_b0}.eps_mesh(2:end),1,'first');
        idx_bchoice = model.policy{idx_y0,idx_b0}.idx_bnext(idx);
        ellND_no_rec(idx_y0) = model.ellND(idx_y0,idx_bchoice);
        defprob_no_rec(idx_y0) = model.defprob(idx_y0,idx_bchoice);
    end
end

plot(defprob_no_rec,(1+ellND_no_rec).^12 - 1,':k','LineWidth',LineWidth)
% title('C. Liquidity premium, no recovery','Interpreter','Latex','FontSize',FontSize)
xlabel('Default probability, one period ahead','Interpreter','Latex','FontSize',FontSize)
ylabel('$\ell_{ND}$, annualized','Interpreter','Latex','FontSize',FontSize)
set(gca,'xlim',[0 0.55])
% axis square
box on

legend({'Baseline','Shorter debt maturity','No recovery'},'Location','NorthWest',...
    'Interpreter','Latex','FontSize',FontSize)
legend boxoff