% the baseline is obtain from:
% ../fit_parms.10142020/fit_parms_10142020_turnover_2016_2019_alg2_rerun.m
% ../fit_parms.10142020/sim_10142020_turnover_2016_2019.m

addpath(genpath('../../RISK_AVERSION/matlab'))
addpath('../../RISK_AVERSION/src_mex')
clear all

%% load data

load('baseline_11042020.mat','p')

p_base = p;
clear p

%% parameters

p.rra = p_base.rra;
p.beta = p_base.beta;
p.clb = p_base.clb;

p.ggq_mstd = p_base.ggq_mstd;
p.ggq_mlb = p_base.ggq_mlb;
p.ggq_mub = p_base.ggq_mub;
p.ggq_mmean = p_base.ggq_mmean;
p.ggq_mDval = p_base.ggq_mDval;

p.errtol_bisect = p_base.errtol_bisect;
p.maxiters_bisect = p_base.maxiters_bisect;
p.r = p_base.rH;
p.holding_cost = p_base.holding_cost;
p.prob_liqshock = p_base.prob_liqshock;
p.prob_meet_mkt_maker_ND = p_base.prob_meet_mkt_maker_ND;
p.prob_meet_mkt_maker_D = p_base.prob_meet_mkt_maker_D;
p.bargain_power_mkt_maker_ND = p_base.bargain_power_mkt_maker_ND;
p.bargain_power_mkt_maker_D = p_base.bargain_power_mkt_maker_D;
p.reenterprob = p_base.reenterprob;
p.debt_z = p_base.debt_z;
p.debt_m = p_base.debt_m;
p.debt_writedown_reentry = p_base.debt_writedown_reentry;
p.max_def_prob = p_base.max_def_prob;
p.recovery_bmax = p_base.recovery_bmax;
% p.gridsize_tfp = 64;
% p.gridsize_b = 256;
p.gridsize_tfp = p_base.gridsize_tfp;
p.gridsize_b = p_base.gridsize_b;
p.bmax = p_base.bmax;
p.grid_b = p_base.grid_b;
p.rho_tfp = p_base.rho_tfp;
p.sigma_tfp = p_base.sigma_tfp;

p.width_std_tfp = 3;
p.conv_chk_width_std_tfp = 2.5;
p.conv_chk_b_ub = 5.5;

p.d_y = p_base.d_y;
p.d_yy = p_base.d_yy;

p.maxiters = p_base.maxiters;
p.errtolV = p_base.errtolV;
p.errtolQ = p_base.errtolQ;
p.NumUpdateRegimes = p_base.NumUpdateRegimes;
p.UpdateRegimeIter = p_base.UpdateRegimeIter;
p.UpdateWeightOldV = p_base.UpdateWeightOldV;
p.UpdateWeightOldQ = p_base.UpdateWeightOldQ;
p.UpdateWeightOldDefProb = p_base.UpdateWeightOldDefProb;

p.width_std_mpr = 3;
p.gridsize_mpr = 16;

p.conv_chk_width_std_mpr = 2.5;

p.mean_mpr = 0.1804;
p.rho_mpr = 0.9885;
p.sigma_mpr = 0.0693;

% see
% C:\Users\yuxus\Dropbox\sovereign.liquidity\Codes\CUDA\JIE.RR.revision1\RISK_AVERSION\arg_us_correlation\calc_corr_Arg_USA.m
p.corr_sdf_tfp_shock = -0.033;

%% solve model on GPU

useDevice = 0;
DisplayInterval = 100;

tic
model_gpu_extended = mexSolveExtendedModelGivenParms(p, useDevice, DisplayInterval);
toc

save('extended_model.mat','model_gpu_extended','p');

%% get policies on CPU

tic
model_gpu_extended_converted = ConvertCPPtoMAT(p,model_gpu_extended);
[model,p] = ProcessMexGPUOutputs_liq(p, model_gpu_extended_converted);
toc

%% simulate

TBurn = 12*10^3;
T = TBurn + 12*10^6;
QuarterLength = 3;
NumQuartersExcludeAfterReentry = 20;

rng(0);
Us_z = rand(T,1);
Us_m = rand(T,1);
Us_x = rand(T,1);
Us_reenter = rand(T,1);

tic
[~,stats] = SimSinglePath(p,model,T,TBurn,Us_z,Us_x,Us_m,Us_reenter,QuarterLength,NumQuartersExcludeAfterReentry);
toc

%% save

save('extended_model.mat','model_gpu_extended','p','model','stats');