function CEconsumption = ComputeWelfare(p,model)

    m0 = p.ggq_mmean;
    
    Vs = zeros(p.gridsize_tfp,1);
    
    for i = 1:p.gridsize_tfp
        
        idx = find(model.policy{i,1}.eps_mesh(1:end-1)<=m0 & m0<=model.policy{i,1}.eps_mesh(2:end),1,'first');
        c = model.policy{i,1}.cs(idx);
        W = model.policy{i,1}.Ws(idx); % this is beta*W
        u = (c + m0)^(1-p.rra)/(1-p.rra) + W;
        Vs(i) = u;
        
    end
    
    [V,D] = eig(p.prob_y');
    [~,idx] = min(abs(1 - diag(D)));
    probs = V(:,idx)/sum(V(:,idx));
    
    EV = sum(probs.*Vs);
    
    % EV = u(c) + beta*EV
    CEconsumption = ((1-p.rra)*(1-p.beta)*EV)^(1/(1-p.rra));

end